diff --git a/src/backend/catalog/information_schema.sql b/src/backend/catalog/information_schema.sql
index 18725a02d1..90004ea3bc 100644
--- a/src/backend/catalog/information_schema.sql
+++ b/src/backend/catalog/information_schema.sql
@@ -293,7 +293,7 @@ CREATE VIEW attributes AS
            CAST(nc.nspname AS sql_identifier) AS udt_schema,
            CAST(c.relname AS sql_identifier) AS udt_name,
            CAST(a.attname AS sql_identifier) AS attribute_name,
-           CAST(a.attnum AS cardinal_number) AS ordinal_position,
+           CAST(a.attphysnum AS cardinal_number) AS ordinal_position,
            CAST(pg_get_expr(ad.adbin, ad.adrelid) AS character_data) AS attribute_default,
            CAST(CASE WHEN a.attnotnull OR (t.typtype = 'd' AND t.typnotnull) THEN 'NO' ELSE 'YES' END
              AS yes_or_no)
@@ -359,16 +359,16 @@ CREATE VIEW attributes AS
            CAST(null AS sql_identifier) AS scope_name,
 
            CAST(null AS cardinal_number) AS maximum_cardinality,
-           CAST(a.attnum AS sql_identifier) AS dtd_identifier,
+           CAST(a.attphysnum AS sql_identifier) AS dtd_identifier,
            CAST('NO' AS yes_or_no) AS is_derived_reference_attribute
 
-    FROM (pg_attribute a LEFT JOIN pg_attrdef ad ON attrelid = adrelid AND attnum = adnum)
+    FROM (pg_attribute a LEFT JOIN pg_attrdef ad ON attrelid = adrelid AND attphysnum = adnum)
          JOIN (pg_class c JOIN pg_namespace nc ON (c.relnamespace = nc.oid)) ON a.attrelid = c.oid
          JOIN (pg_type t JOIN pg_namespace nt ON (t.typnamespace = nt.oid)) ON a.atttypid = t.oid
          LEFT JOIN (pg_collation co JOIN pg_namespace nco ON (co.collnamespace = nco.oid))
            ON a.attcollation = co.oid AND (nco.nspname, co.collname) <> ('pg_catalog', 'default')
 
-    WHERE a.attnum > 0 AND NOT a.attisdropped
+    WHERE a.attphysnum > 0 AND NOT a.attisdropped
           AND c.relkind IN ('c')
           AND (pg_has_role(c.relowner, 'USAGE')
                OR has_type_privilege(c.reltype, 'USAGE'));
@@ -449,13 +449,13 @@ CREATE VIEW check_constraints AS
 
     SELECT CAST(current_database() AS sql_identifier) AS constraint_catalog,
            CAST(n.nspname AS sql_identifier) AS constraint_schema,
-           CAST(CAST(n.oid AS text) || '_' || CAST(r.oid AS text) || '_' || CAST(a.attnum AS text) || '_not_null' AS sql_identifier) AS constraint_name, -- XXX
+           CAST(CAST(n.oid AS text) || '_' || CAST(r.oid AS text) || '_' || CAST(a.attphysnum AS text) || '_not_null' AS sql_identifier) AS constraint_name, -- XXX
            CAST(a.attname || ' IS NOT NULL' AS character_data)
              AS check_clause
     FROM pg_namespace n, pg_class r, pg_attribute a
     WHERE n.oid = r.relnamespace
       AND r.oid = a.attrelid
-      AND a.attnum > 0
+      AND a.attphysnum > 0
       AND NOT a.attisdropped
       AND a.attnotnull
       AND r.relkind IN ('r', 'p')
@@ -519,14 +519,14 @@ CREATE VIEW column_column_usage AS
     WHERE n.oid = c.relnamespace
           AND c.oid = ac.attrelid
           AND c.oid = ad.attrelid
-          AND ac.attnum <> ad.attnum
+          AND ac.attphysnum <> ad.attphysnum
           AND ad.attrelid = atd.adrelid
-          AND ad.attnum = atd.adnum
+          AND ad.attphysnum = atd.adnum
           AND d.classid = 'pg_catalog.pg_attrdef'::regclass
           AND d.refclassid = 'pg_catalog.pg_class'::regclass
           AND d.objid = atd.oid
           AND d.refobjid = ac.attrelid
-          AND d.refobjsubid = ac.attnum
+          AND d.refobjsubid = ac.attphysnum
           AND ad.attgenerated <> ''
           AND pg_has_role(c.relowner, 'USAGE');
 
@@ -556,7 +556,7 @@ CREATE VIEW column_domain_usage AS
           AND a.atttypid = t.oid
           AND t.typtype = 'd'
           AND c.relkind IN ('r', 'v', 'f', 'p')
-          AND a.attnum > 0
+          AND a.attphysnum > 0
           AND NOT a.attisdropped
           AND pg_has_role(t.typowner, 'USAGE');
 
@@ -598,7 +598,7 @@ CREATE VIEW column_privileges AS
                 ) pr_c (oid, relname, relnamespace, relowner, grantor, grantee, prtype, grantable),
                 pg_attribute a
            WHERE a.attrelid = pr_c.oid
-                 AND a.attnum > 0
+                 AND a.attphysnum > 0
                  AND NOT a.attisdropped
            UNION
            SELECT pr_a.grantor,
@@ -611,7 +611,7 @@ CREATE VIEW column_privileges AS
                   c.relowner
            FROM (SELECT attrelid, attname, (aclexplode(coalesce(attacl, acldefault('c', relowner)))).*
                  FROM pg_attribute a JOIN pg_class cc ON (a.attrelid = cc.oid)
-                 WHERE attnum > 0
+                 WHERE attphysnum > 0
                        AND NOT attisdropped
                 ) pr_a (attrelid, attname, grantor, grantee, prtype, grantable),
                 pg_class c
@@ -659,7 +659,7 @@ CREATE VIEW column_udt_usage AS
     WHERE a.attrelid = c.oid
           AND a.atttypid = t.oid
           AND nc.oid = c.relnamespace
-          AND a.attnum > 0 AND NOT a.attisdropped
+          AND a.attphysnum > 0 AND NOT a.attisdropped
           AND c.relkind in ('r', 'v', 'f', 'p')
           AND pg_has_role(coalesce(bt.typowner, t.typowner), 'USAGE');
 
@@ -676,7 +676,7 @@ CREATE VIEW columns AS
            CAST(nc.nspname AS sql_identifier) AS table_schema,
            CAST(c.relname AS sql_identifier) AS table_name,
            CAST(a.attname AS sql_identifier) AS column_name,
-           CAST(a.attnum AS cardinal_number) AS ordinal_position,
+           CAST(a.attphysnum AS cardinal_number) AS ordinal_position,
            CAST(CASE WHEN a.attgenerated = '' THEN pg_get_expr(ad.adbin, ad.adrelid) END AS character_data) AS column_default,
            CAST(CASE WHEN a.attnotnull OR (t.typtype = 'd' AND t.typnotnull) THEN 'NO' ELSE 'YES' END
              AS yes_or_no)
@@ -755,7 +755,7 @@ CREATE VIEW columns AS
            CAST(null AS sql_identifier) AS scope_name,
 
            CAST(null AS cardinal_number) AS maximum_cardinality,
-           CAST(a.attnum AS sql_identifier) AS dtd_identifier,
+           CAST(a.attphysnum AS sql_identifier) AS dtd_identifier,
            CAST('NO' AS yes_or_no) AS is_self_referencing,
 
            CAST(CASE WHEN a.attidentity IN ('a', 'd') THEN 'YES' ELSE 'NO' END AS yes_or_no) AS is_identity,
@@ -771,10 +771,10 @@ CREATE VIEW columns AS
 
            CAST(CASE WHEN c.relkind IN ('r', 'p') OR
                           (c.relkind IN ('v', 'f') AND
-                           pg_column_is_updatable(c.oid, a.attnum, false))
+                           pg_column_is_updatable(c.oid, a.attphysnum, false))
                 THEN 'YES' ELSE 'NO' END AS yes_or_no) AS is_updatable
 
-    FROM (pg_attribute a LEFT JOIN pg_attrdef ad ON attrelid = adrelid AND attnum = adnum)
+    FROM (pg_attribute a LEFT JOIN pg_attrdef ad ON attrelid = adrelid AND attphysnum = adnum)
          JOIN (pg_class c JOIN pg_namespace nc ON (c.relnamespace = nc.oid)) ON a.attrelid = c.oid
          JOIN (pg_type t JOIN pg_namespace nt ON (t.typnamespace = nt.oid)) ON a.atttypid = t.oid
          LEFT JOIN (pg_type bt JOIN pg_namespace nbt ON (bt.typnamespace = nbt.oid))
@@ -782,15 +782,15 @@ CREATE VIEW columns AS
          LEFT JOIN (pg_collation co JOIN pg_namespace nco ON (co.collnamespace = nco.oid))
            ON a.attcollation = co.oid AND (nco.nspname, co.collname) <> ('pg_catalog', 'default')
          LEFT JOIN (pg_depend dep JOIN pg_sequence seq ON (dep.classid = 'pg_class'::regclass AND dep.objid = seq.seqrelid AND dep.deptype = 'i'))
-           ON (dep.refclassid = 'pg_class'::regclass AND dep.refobjid = c.oid AND dep.refobjsubid = a.attnum)
+           ON (dep.refclassid = 'pg_class'::regclass AND dep.refobjid = c.oid AND dep.refobjsubid = a.attphysnum)
 
     WHERE (NOT pg_is_other_temp_schema(nc.oid))
 
-          AND a.attnum > 0 AND NOT a.attisdropped
+          AND a.attphysnum > 0 AND NOT a.attisdropped
           AND c.relkind IN ('r', 'v', 'f', 'p')
 
           AND (pg_has_role(c.relowner, 'USAGE')
-               OR has_column_privilege(c.oid, a.attnum,
+               OR has_column_privilege(c.oid, a.attphysnum,
                                        'SELECT, INSERT, UPDATE, REFERENCES'));
 
 GRANT SELECT ON columns TO PUBLIC;
@@ -818,7 +818,7 @@ CREATE VIEW constraint_column_usage AS
             AND r.oid = a.attrelid
             AND d.refclassid = 'pg_catalog.pg_class'::regclass
             AND d.refobjid = r.oid
-            AND d.refobjsubid = a.attnum
+            AND d.refobjsubid = a.attphysnum
             AND d.classid = 'pg_catalog.pg_constraint'::regclass
             AND d.objid = c.oid
             AND c.connamespace = nc.oid
@@ -836,7 +836,7 @@ CREATE VIEW constraint_column_usage AS
             AND r.oid = a.attrelid
             AND nc.oid = c.connamespace
             AND r.oid = CASE c.contype WHEN 'f' THEN c.confrelid ELSE c.conrelid END
-            AND a.attnum = ANY (CASE c.contype WHEN 'f' THEN c.confkey ELSE c.conkey END)
+            AND a.attphysnum = ANY (CASE c.contype WHEN 'f' THEN c.confkey ELSE c.conkey END)
             AND NOT a.attisdropped
             AND c.contype IN ('p', 'u', 'f')
             AND r.relkind IN ('r', 'p')
@@ -1095,10 +1095,10 @@ CREATE VIEW key_column_usage AS
                 AND r.relkind IN ('r', 'p')
                 AND (NOT pg_is_other_temp_schema(nr.oid)) ) AS ss
     WHERE ss.roid = a.attrelid
-          AND a.attnum = (ss.x).x
+          AND a.attphysnum = (ss.x).x
           AND NOT a.attisdropped
           AND (pg_has_role(relowner, 'USAGE')
-               OR has_column_privilege(roid, a.attnum,
+               OR has_column_privilege(roid, a.attphysnum,
                                        'SELECT, INSERT, UPDATE, REFERENCES'));
 
 GRANT SELECT ON key_column_usage TO PUBLIC;
@@ -1352,7 +1352,7 @@ CREATE VIEW routine_column_usage AS
           AND t.relnamespace = nt.oid
           AND t.relkind IN ('r', 'v', 'f', 'p')
           AND t.oid = a.attrelid
-          AND d.refobjsubid = a.attnum
+          AND d.refobjsubid = a.attphysnum
           AND pg_has_role(t.relowner, 'USAGE');
 
 GRANT SELECT ON routine_column_usage TO PUBLIC;
@@ -1867,7 +1867,7 @@ CREATE VIEW table_constraints AS
 
     SELECT CAST(current_database() AS sql_identifier) AS constraint_catalog,
            CAST(nr.nspname AS sql_identifier) AS constraint_schema,
-           CAST(CAST(nr.oid AS text) || '_' || CAST(r.oid AS text) || '_' || CAST(a.attnum AS text) || '_not_null' AS sql_identifier) AS constraint_name, -- XXX
+           CAST(CAST(nr.oid AS text) || '_' || CAST(r.oid AS text) || '_' || CAST(a.attphysnum AS text) || '_not_null' AS sql_identifier) AS constraint_name, -- XXX
            CAST(current_database() AS sql_identifier) AS table_catalog,
            CAST(nr.nspname AS sql_identifier) AS table_schema,
            CAST(r.relname AS sql_identifier) AS table_name,
@@ -1884,7 +1884,7 @@ CREATE VIEW table_constraints AS
     WHERE nr.oid = r.relnamespace
           AND r.oid = a.attrelid
           AND a.attnotnull
-          AND a.attnum > 0
+          AND a.attphysnum > 0
           AND NOT a.attisdropped
           AND r.relkind IN ('r', 'p')
           AND (NOT pg_is_other_temp_schema(nr.oid))
@@ -2084,12 +2084,12 @@ CREATE VIEW triggered_update_columns AS
     WHERE n.oid = c.relnamespace
           AND c.oid = t.tgrelid
           AND t.oid = ta.tgoid
-          AND (a.attrelid, a.attnum) = (t.tgrelid, ta.tgattnum)
+          AND (a.attrelid, a.attphysnum) = (t.tgrelid, ta.tgattnum)
           AND NOT t.tgisinternal
           AND (NOT pg_is_other_temp_schema(n.oid))
           AND (pg_has_role(c.relowner, 'USAGE')
                -- SELECT privilege omitted, per SQL standard
-               OR has_column_privilege(c.oid, a.attnum, 'INSERT, UPDATE, REFERENCES') );
+               OR has_column_privilege(c.oid, a.attphysnum, 'INSERT, UPDATE, REFERENCES') );
 
 GRANT SELECT ON triggered_update_columns TO PUBLIC;
 
@@ -2537,7 +2537,7 @@ CREATE VIEW view_column_usage AS
           AND t.relnamespace = nt.oid
           AND t.relkind IN ('r', 'v', 'f', 'p')
           AND t.oid = a.attrelid
-          AND dt.refobjsubid = a.attnum
+          AND dt.refobjsubid = a.attphysnum
           AND pg_has_role(t.relowner, 'USAGE');
 
 GRANT SELECT ON view_column_usage TO PUBLIC;
@@ -2763,11 +2763,11 @@ CREATE VIEW element_types AS
            /* columns, attributes */
            SELECT c.relnamespace, CAST(c.relname AS sql_identifier),
                   CASE WHEN c.relkind = 'c' THEN 'USER-DEFINED TYPE'::text ELSE 'TABLE'::text END,
-                  a.attnum, a.atttypid, a.attcollation
+                  a.attphysnum, a.atttypid, a.attcollation
            FROM pg_class c, pg_attribute a
            WHERE c.oid = a.attrelid
                  AND c.relkind IN ('r', 'v', 'f', 'c', 'p')
-                 AND attnum > 0 AND NOT attisdropped
+                 AND attphysnum > 0 AND NOT attisdropped
 
            UNION ALL
 
@@ -2824,12 +2824,12 @@ CREATE VIEW _pg_foreign_table_columns AS
          pg_attribute a
     WHERE u.oid = c.relowner
           AND (pg_has_role(c.relowner, 'USAGE')
-               OR has_column_privilege(c.oid, a.attnum, 'SELECT, INSERT, UPDATE, REFERENCES'))
+               OR has_column_privilege(c.oid, a.attphysnum, 'SELECT, INSERT, UPDATE, REFERENCES'))
           AND n.oid = c.relnamespace
           AND c.oid = t.ftrelid
           AND c.relkind = 'f'
           AND a.attrelid = c.oid
-          AND a.attnum > 0;
+          AND a.attphysnum > 0;
 
 /*
  * 24.2
diff --git a/src/backend/catalog/objectaddress.c b/src/backend/catalog/objectaddress.c
index 8377b4f7d4..e373637651 100644
--- a/src/backend/catalog/objectaddress.c
+++ b/src/backend/catalog/objectaddress.c
@@ -107,10 +107,10 @@ typedef struct
 									 * (name) if the object does not live in a
 									 * namespace */
 	AttrNumber	attnum_oid;		/* attribute number of oid column */
-	AttrNumber	attnum_name;	/* attnum of name field */
-	AttrNumber	attnum_namespace;	/* attnum of namespace field */
-	AttrNumber	attnum_owner;	/* attnum of owner field */
-	AttrNumber	attnum_acl;		/* attnum of acl field */
+	AttrNumber	attnum_name;	/* attphysnum of name field */
+	AttrNumber	attnum_namespace;	/* attphysnum of namespace field */
+	AttrNumber	attnum_owner;	/* attphysnum of owner field */
+	AttrNumber	attnum_acl;		/* attphysnum of acl field */
 	ObjectType	objtype;		/* OBJECT_* of this object type */
 	bool		is_nsp_name_unique; /* can the nsp/name combination (or name
 									 * alone, if there's no namespace) be
@@ -1520,7 +1520,7 @@ get_object_address_attribute(ObjectType objtype, List *object,
 	Oid			reloid;
 	Relation	relation;
 	const char *attname;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 
 	/* Extract relation name and open relation. */
 	if (list_length(object) < 2)
@@ -1534,8 +1534,8 @@ get_object_address_attribute(ObjectType objtype, List *object,
 	reloid = RelationGetRelid(relation);
 
 	/* Look up attribute and construct return value. */
-	attnum = get_attnum(reloid, attname);
-	if (attnum == InvalidAttrNumber)
+	attphysnum = get_attphysnum(reloid, attname);
+	if (attphysnum == InvalidAttrNumber)
 	{
 		if (!missing_ok)
 			ereport(ERROR,
@@ -1552,7 +1552,7 @@ get_object_address_attribute(ObjectType objtype, List *object,
 
 	address.classId = RelationRelationId;
 	address.objectId = reloid;
-	address.objectSubId = attnum;
+	address.objectSubId = attphysnum;
 
 	*relp = relation;
 	return address;
@@ -1571,7 +1571,7 @@ get_object_address_attrdef(ObjectType objtype, List *object,
 	Oid			reloid;
 	Relation	relation;
 	const char *attname;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 	TupleDesc	tupdesc;
 	Oid			defoid;
 
@@ -1589,10 +1589,10 @@ get_object_address_attrdef(ObjectType objtype, List *object,
 	tupdesc = RelationGetDescr(relation);
 
 	/* Look up attribute number and fetch the pg_attrdef OID */
-	attnum = get_attnum(reloid, attname);
+	attphysnum = get_attphysnum(reloid, attname);
 	defoid = InvalidOid;
-	if (attnum != InvalidAttrNumber && tupdesc->constr != NULL)
-		defoid = GetAttrDefaultOid(reloid, attnum);
+	if (attphysnum != InvalidAttrNumber && tupdesc->constr != NULL)
+		defoid = GetAttrDefaultOid(reloid, attphysnum);
 	if (!OidIsValid(defoid))
 	{
 		if (!missing_ok)
diff --git a/src/backend/catalog/pg_attrdef.c b/src/backend/catalog/pg_attrdef.c
index c5d4a9912e..8587796e0b 100644
--- a/src/backend/catalog/pg_attrdef.c
+++ b/src/backend/catalog/pg_attrdef.c
@@ -32,7 +32,7 @@
 
 
 /*
- * Store a default expression for column attnum of relation rel.
+ * Store a default expression for column attphysnum of relation rel.
  *
  * Returns the OID of the new pg_attrdef tuple.
  *
@@ -43,7 +43,7 @@
  * in effect be changing existing tuples.
  */
 Oid
-StoreAttrDefault(Relation rel, AttrNumber attnum,
+StoreAttrDefault(Relation rel, AttrNumber attphysnum,
 				 Node *expr, bool is_internal, bool add_column_mode)
 {
 	char	   *adbin;
@@ -73,7 +73,7 @@ StoreAttrDefault(Relation rel, AttrNumber attnum,
 									Anum_pg_attrdef_oid);
 	values[Anum_pg_attrdef_oid - 1] = ObjectIdGetDatum(attrdefOid);
 	values[Anum_pg_attrdef_adrelid - 1] = RelationGetRelid(rel);
-	values[Anum_pg_attrdef_adnum - 1] = attnum;
+	values[Anum_pg_attrdef_adnum - 1] = attphysnum;
 	values[Anum_pg_attrdef_adbin - 1] = CStringGetTextDatum(adbin);
 
 	tuple = heap_form_tuple(adrel->rd_att, values, nulls);
@@ -95,12 +95,12 @@ StoreAttrDefault(Relation rel, AttrNumber attnum,
 	 * exists.
 	 */
 	attrrel = table_open(AttributeRelationId, RowExclusiveLock);
-	atttup = SearchSysCacheCopy2(ATTNUM,
+	atttup = SearchSysCacheCopy2(ATTPHYSNUM,
 								 ObjectIdGetDatum(RelationGetRelid(rel)),
-								 Int16GetDatum(attnum));
+								 Int16GetDatum(attphysnum));
 	if (!HeapTupleIsValid(atttup))
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
-			 attnum, RelationGetRelid(rel));
+			 attphysnum, RelationGetRelid(rel));
 	attStruct = (Form_pg_attribute) GETSTRUCT(atttup);
 	attgenerated = attStruct->attgenerated;
 	if (!attStruct->atthasdef)
@@ -136,7 +136,7 @@ StoreAttrDefault(Relation rel, AttrNumber attnum,
 
 			FreeExecutorState(estate);
 
-			defAttStruct = TupleDescAttr(rel->rd_att, attnum - 1);
+			defAttStruct = TupleDescAttr(rel->rd_att, attphysnum - 1);
 
 			if (missingIsNull)
 			{
@@ -179,7 +179,7 @@ StoreAttrDefault(Relation rel, AttrNumber attnum,
 	 */
 	colobject.classId = RelationRelationId;
 	colobject.objectId = RelationGetRelid(rel);
-	colobject.objectSubId = attnum;
+	colobject.objectSubId = attphysnum;
 
 	recordDependencyOn(&defobject, &colobject,
 					   attgenerated ? DEPENDENCY_INTERNAL : DEPENDENCY_AUTO);
@@ -200,7 +200,7 @@ StoreAttrDefault(Relation rel, AttrNumber attnum,
 	 * needs to distinguish.
 	 */
 	InvokeObjectPostCreateHookArg(AttrDefaultRelationId,
-								  RelationGetRelid(rel), attnum, is_internal);
+								  RelationGetRelid(rel), attphysnum, is_internal);
 
 	return attrdefOid;
 }
@@ -213,7 +213,7 @@ StoreAttrDefault(Relation rel, AttrNumber attnum,
  * (If no default, raise error if complain is true, else return quietly.)
  */
 void
-RemoveAttrDefault(Oid relid, AttrNumber attnum,
+RemoveAttrDefault(Oid relid, AttrNumber attphysnum,
 				  DropBehavior behavior, bool complain, bool internal)
 {
 	Relation	attrdef_rel;
@@ -231,7 +231,7 @@ RemoveAttrDefault(Oid relid, AttrNumber attnum,
 	ScanKeyInit(&scankeys[1],
 				Anum_pg_attrdef_adnum,
 				BTEqualStrategyNumber, F_INT2EQ,
-				Int16GetDatum(attnum));
+				Int16GetDatum(attphysnum));
 
 	scan = systable_beginscan(attrdef_rel, AttrDefaultIndexId, true,
 							  NULL, 2, scankeys);
@@ -256,8 +256,8 @@ RemoveAttrDefault(Oid relid, AttrNumber attnum,
 	table_close(attrdef_rel, RowExclusiveLock);
 
 	if (complain && !found)
-		elog(ERROR, "could not find attrdef tuple for relation %u attnum %d",
-			 relid, attnum);
+		elog(ERROR, "could not find attrdef tuple for relation %u attphysnum %d",
+			 relid, attphysnum);
 }
 
 /*
@@ -310,7 +310,7 @@ RemoveAttrDefaultById(Oid attrdefId)
 	/* Fix the pg_attribute row */
 	attr_rel = table_open(AttributeRelationId, RowExclusiveLock);
 
-	tuple = SearchSysCacheCopy2(ATTNUM,
+	tuple = SearchSysCacheCopy2(ATTPHYSNUM,
 								ObjectIdGetDatum(myrelid),
 								Int16GetDatum(myattnum));
 	if (!HeapTupleIsValid(tuple))	/* shouldn't happen */
@@ -339,7 +339,7 @@ RemoveAttrDefaultById(Oid attrdefId)
  * Returns InvalidOid if there is no such pg_attrdef entry.
  */
 Oid
-GetAttrDefaultOid(Oid relid, AttrNumber attnum)
+GetAttrDefaultOid(Oid relid, AttrNumber attphysnum)
 {
 	Oid			result = InvalidOid;
 	Relation	attrdef;
@@ -357,7 +357,7 @@ GetAttrDefaultOid(Oid relid, AttrNumber attnum)
 				Anum_pg_attrdef_adnum,
 				BTEqualStrategyNumber,
 				F_INT2EQ,
-				Int16GetDatum(attnum));
+				Int16GetDatum(attphysnum));
 	scan = systable_beginscan(attrdef, AttrDefaultIndexId, true,
 							  NULL, 2, keys);
 
diff --git a/src/backend/catalog/pg_depend.c b/src/backend/catalog/pg_depend.c
index e86e5e6898..e8a2be6fc7 100644
--- a/src/backend/catalog/pg_depend.c
+++ b/src/backend/catalog/pg_depend.c
@@ -816,7 +816,7 @@ sequenceIsOwned(Oid seqId, char deptype, Oid *tableId, int32 *colId)
  * with the specified dependency type.
  */
 static List *
-getOwnedSequences_internal(Oid relid, AttrNumber attnum, char deptype)
+getOwnedSequences_internal(Oid relid, AttrNumber attphysnum, char deptype)
 {
 	List	   *result = NIL;
 	Relation	depRel;
@@ -834,14 +834,14 @@ getOwnedSequences_internal(Oid relid, AttrNumber attnum, char deptype)
 				Anum_pg_depend_refobjid,
 				BTEqualStrategyNumber, F_OIDEQ,
 				ObjectIdGetDatum(relid));
-	if (attnum)
+	if (attphysnum)
 		ScanKeyInit(&key[2],
 					Anum_pg_depend_refobjsubid,
 					BTEqualStrategyNumber, F_INT4EQ,
-					Int32GetDatum(attnum));
+					Int32GetDatum(attphysnum));
 
 	scan = systable_beginscan(depRel, DependReferenceIndexId, true,
-							  NULL, attnum ? 3 : 2, key);
+							  NULL, attphysnum ? 3 : 2, key);
 
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
@@ -884,9 +884,9 @@ getOwnedSequences(Oid relid)
  * Get owned identity sequence, error if not exactly one.
  */
 Oid
-getIdentitySequence(Oid relid, AttrNumber attnum, bool missing_ok)
+getIdentitySequence(Oid relid, AttrNumber attphysnum, bool missing_ok)
 {
-	List	   *seqlist = getOwnedSequences_internal(relid, attnum, DEPENDENCY_INTERNAL);
+	List	   *seqlist = getOwnedSequences_internal(relid, attphysnum, DEPENDENCY_INTERNAL);
 
 	if (list_length(seqlist) > 1)
 		elog(ERROR, "more than one owned sequence found");
diff --git a/src/backend/catalog/pg_publication.c b/src/backend/catalog/pg_publication.c
index c365de3a72..0a8cefe637 100644
--- a/src/backend/catalog/pg_publication.c
+++ b/src/backend/catalog/pg_publication.c
@@ -502,34 +502,34 @@ publication_translate_columns(Relation targetrel, List *columns,
 	foreach(lc, columns)
 	{
 		char	   *colname = strVal(lfirst(lc));
-		AttrNumber	attnum = get_attnum(RelationGetRelid(targetrel), colname);
+		AttrNumber	attphysnum = get_attphysnum(RelationGetRelid(targetrel), colname);
 
-		if (attnum == InvalidAttrNumber)
+		if (attphysnum == InvalidAttrNumber)
 			ereport(ERROR,
 					errcode(ERRCODE_UNDEFINED_COLUMN),
 					errmsg("column \"%s\" of relation \"%s\" does not exist",
 						   colname, RelationGetRelationName(targetrel)));
 
-		if (!AttrNumberIsForUserDefinedAttr(attnum))
+		if (!AttrNumberIsForUserDefinedAttr(attphysnum))
 			ereport(ERROR,
 					errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
 					errmsg("cannot reference system column \"%s\" in publication column list",
 						   colname));
 
-		if (TupleDescAttr(tupdesc, attnum - 1)->attgenerated)
+		if (TupleDescAttr(tupdesc, attphysnum - 1)->attgenerated)
 			ereport(ERROR,
 					errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
 					errmsg("cannot reference generated column \"%s\" in publication column list",
 						   colname));
 
-		if (bms_is_member(attnum, set))
+		if (bms_is_member(attphysnum, set))
 			ereport(ERROR,
 					errcode(ERRCODE_DUPLICATE_OBJECT),
 					errmsg("duplicate column \"%s\" in publication column list",
 						   colname));
 
-		set = bms_add_member(set, attnum);
-		attarray[n++] = attnum;
+		set = bms_add_member(set, attphysnum);
+		attarray[n++] = attphysnum;
 	}
 
 	/* Be tidy, so that the catalog representation is always sorted */
diff --git a/src/backend/catalog/system_views.sql b/src/backend/catalog/system_views.sql
index fedaed533b..37b7edc2db 100644
--- a/src/backend/catalog/system_views.sql
+++ b/src/backend/catalog/system_views.sql
@@ -245,10 +245,10 @@ CREATE VIEW pg_stats WITH (security_barrier) AS
             WHEN stakind5 = 5 THEN stanumbers5
         END AS elem_count_histogram
     FROM pg_statistic s JOIN pg_class c ON (c.oid = s.starelid)
-         JOIN pg_attribute a ON (c.oid = attrelid AND attnum = s.staattnum)
+         JOIN pg_attribute a ON (c.oid = attrelid AND attphysnum = s.staattnum)
          LEFT JOIN pg_namespace n ON (n.oid = c.relnamespace)
     WHERE NOT attisdropped
-    AND has_column_privilege(c.oid, a.attnum, 'select')
+    AND has_column_privilege(c.oid, a.attphysnum, 'select')
     AND (c.relrowsecurity = false OR NOT row_security_active(c.oid));
 
 REVOKE ALL ON pg_statistic FROM public;
@@ -259,10 +259,10 @@ CREATE VIEW pg_stats_ext WITH (security_barrier) AS
            sn.nspname AS statistics_schemaname,
            s.stxname AS statistics_name,
            pg_get_userbyid(s.stxowner) AS statistics_owner,
-           ( SELECT array_agg(a.attname ORDER BY a.attnum)
+           ( SELECT array_agg(a.attname ORDER BY a.attphysnum)
              FROM unnest(s.stxkeys) k
                   JOIN pg_attribute a
-                       ON (a.attrelid = s.stxrelid AND a.attnum = k)
+                       ON (a.attrelid = s.stxrelid AND a.attphysnum = k)
            ) AS attnames,
            pg_get_statisticsobjdef_expressions(s.oid) as exprs,
            s.stxkind AS kinds,
@@ -288,8 +288,8 @@ CREATE VIEW pg_stats_ext WITH (security_barrier) AS
               ( SELECT 1
                 FROM unnest(stxkeys) k
                      JOIN pg_attribute a
-                          ON (a.attrelid = s.stxrelid AND a.attnum = k)
-                WHERE NOT has_column_privilege(c.oid, a.attnum, 'select') )
+                          ON (a.attrelid = s.stxrelid AND a.attphysnum = k)
+                WHERE NOT has_column_privilege(c.oid, a.attphysnum, 'select') )
     AND (c.relrowsecurity = false OR NOT row_security_active(c.oid));
 
 CREATE VIEW pg_stats_ext_exprs WITH (security_barrier) AS
@@ -369,12 +369,12 @@ CREATE VIEW pg_publication_tables AS
         P.pubname AS pubname,
         N.nspname AS schemaname,
         C.relname AS tablename,
-        ( SELECT array_agg(a.attname ORDER BY a.attnum)
+        ( SELECT array_agg(a.attname ORDER BY a.attphysnum)
           FROM unnest(CASE WHEN GPT.attrs IS NOT NULL THEN GPT.attrs
                       ELSE (SELECT array_agg(g) FROM generate_series(1, C.relnatts) g)
                       END) k
                JOIN pg_attribute a
-                    ON (a.attrelid = GPT.relid AND a.attnum = k)
+                    ON (a.attrelid = GPT.relid AND a.attphysnum = k)
         ) AS attnames,
         pg_get_expr(GPT.qual, GPT.relid) AS rowfilter
     FROM pg_publication P,
@@ -446,7 +446,7 @@ FROM
     pg_seclabel l
     JOIN pg_class rel ON l.classoid = rel.tableoid AND l.objoid = rel.oid
     JOIN pg_attribute att
-         ON rel.oid = att.attrelid AND l.objsubid = att.attnum
+         ON rel.oid = att.attrelid AND l.objsubid = att.attphysnum
     JOIN pg_namespace nsp ON rel.relnamespace = nsp.oid
 WHERE
     l.objsubid != 0
